// Generated by CoffeeScript 1.11.1

/*
CoffeeScript language component for Nesh, the Node.js enhanced shell.
 */

(function() {
  var coffee, log, path, semver;

  require('colors');

  coffee = require('coffee-script');

  log = require('../log');

  path = require('path');

  semver = require('semver');

  exports.setup = function(context) {
    var nesh;
    nesh = context.nesh;
    log.debug('Loading CoffeeScript');
    nesh.compile = function(data) {
      return coffee.compile(data, {
        bare: true,
        header: false
      });
    };
    nesh.repl = require('coffee-script/lib/coffee-script/repl');
    process.versions['coffee-script'] = coffee.VERSION;
    nesh.defaults.welcome = ("CoffeeScript " + coffee.VERSION + " on Node " + process.version + "\nType ") + '.help'.cyan + ' for more information';
    nesh.defaults.prompt = 'coffee> ';
    nesh.defaults.useGlobal = semver.satisfies(coffee.VERSION, "> 1.6.3");
    if (!nesh.defaults.useGlobal) {
      log.warn('Warning: inherited global context requires CoffeeScript > 1.6.3');
      log.warn('         packages that modify built-in prototypes may not work');
    }
    return nesh.defaults.historyFile = path.join(nesh.config.home, '.coffee_history');
  };

}).call(this);

//# sourceMappingURL=coffee.js.map
